 echo off

 REM compiler.bat
 REM ============

 REM This file is part of Gerolf Markup Shredder,
 REM written by G. D. Brettschneider (1999-2006).

 REM GMSdatecompiler=20060927

 REM ==========================================================================

 REM If necesssary, read launcher script to load environment:

 if not "%GMS_BATCH%" == "" goto fi_ll
   call gerolf -passive
   if not "%GMS_BATCH%" == "" goto fi_lll
     echo  GMS error: Could not set environment variables. 
     echo  Run 'gmssetup' to create GMS launcher script 'gerolf'!
     pause > nul
     echo.
     goto exit 
   :fi_lll
 :fi_ll

 REM Debug: -------------------------------------------------------------------

 if "%OS%" == "" goto fi_db
 if -%GMS_DEBUG% == - goto fi_db
   if %GMS_DEBUG% == Z echo %0 (%1) (%2) (%3) (%4) (%5) (%6) (%7) (%8)>> %Z%
 :fi_db

 REM Check if bat2exec compiler is present: -----------------------------------

 REM set COMPILER=%GMS_BINARIES%\bat2exec.com

 REM if exist %GMS_BINARIES%\bat2exec.com goto fi_1
 if "%OS%" == "" if exist %GMS_BINARIES%\bat2exec.com goto fi_1
 if not "%OS%" == "" if exist "%GMS_BINARIES%\bat2exec.com" goto fi_1
   echo  GMS error:    Missing '%GMS_BINARIES%\bat2exec.com'.
   echo.
   goto exit
 :fi_1 

 REM Convert batch files into binaries: ---------------------------------------

 REM cd %GMS_BATCH% > nul
 if "%OS%" == "" cd %GMS_BATCH% > nul
 if not "%OS%" == "" cd "%GMS_BATCH%" > nul

 if not "%1" == "" goto fi_2
   cls
   echo  compiler.log - GMS: Running batch compiler and syntax checker ...
   REM type %GMS_SETTING%\desktop.scn
   if "%OS%" == "" type %GMS_SETTING%\desktop.scn
   if not "%OS%" == "" type "%GMS_SETTING%\desktop.scn"
   echo  %GMS_BATCH%
 :fi_2

 set GMS_PROGRAM=batch compiler

 REM Compilation is only possible for command scripts that do neither assign-
 REM ments to "globally" used environment variables nor output redirection to
 REM a file. No whitespace is allowed behind file names.
     
 echo GMS: browser.bat --->> compiler.txt
   bat2exec browser.bat>> compiler.txt
     if exist browser.com del browser.com
     
 echo GMS: compiler.bat --->> compiler.txt
   bat2exec compiler.bat>> compiler.txt
     if exist compiler.com del compiler.com
     
 echo GMS: editor.bat --->> compiler.txt
   bat2exec editor.bat>> compiler.txt
     if exist editor.com del editor.com
     
 echo GMS: folder.bat --->> compiler.txt
 if "%OS%" == "" copy %GMS_SETTING%\folder.bat> nul
 if not "%OS%" == "" copy "%GMS_SETTING%\folder.bat"> nul
   bat2exec folder.bat>> compiler.txt
     if exist folder.com del folder.com
     if exist folder.bat del folder.bat

 echo GMS: g_code.bat --->> compiler.txt
   bat2exec g_code.bat>> compiler.txt
     if exist g_code.com del g_code.com
 echo GMS: g_color.bat --->> compiler.txt
   bat2exec g_color.bat>> compiler.txt
     if exist g_color.com del g_color.com
 echo GMS: g_dos.bat --->> compiler.txt
   bat2exec g_dos.bat>> compiler.txt
     if exist g_dos.com del g_dos.com
 echo GMS: g_file.bat --->> compiler.txt
   bat2exec g_file.bat>> compiler.txt
     if exist g_file.com del g_file.com
 echo GMS: g_font.bat --->> compiler.txt
   bat2exec g_font.bat>> compiler.txt
     if exist g_font.com del g_font.com
 echo GMS: g_good.bat --->> compiler.txt
   bat2exec g_good.bat>> compiler.txt
     if exist g_good.com del g_good.com
 echo GMS: g_launch.bat --->> compiler.txt
   bat2exec g_launch.bat>> compiler.txt
     if exist g_launch.com del g_launch.com
 echo GMS: g_list.bat --->> compiler.txt
   bat2exec g_list.bat>> compiler.txt
     if exist g_list.com del g_list.com
 echo GMS: g_menu.bat --->> compiler.txt
   bat2exec g_menu.bat>> compiler.txt
     if exist g_menu.com del g_menu.com
 echo GMS: g_palet.bat --->> compiler.txt
   bat2exec g_palet.bat>> compiler.txt
     if exist g_palet.com del g_palet.com
 echo GMS: g_plug.bat --->> compiler.txt
   bat2exec g_plug.bat>> compiler.txt
     if exist g_plug.com del g_plug.com
 echo GMS: g_prog.bat --->> compiler.txt
   bat2exec g_prog.bat>> compiler.txt
     if exist g_prog.com del g_prog.com
 echo GMS: g_rain.bat --->> compiler.txt
   bat2exec g_rain.bat>> compiler.txt
     if exist g_rain.com del g_rain.com
 echo GMS: g_save.bat --->> compiler.txt
   bat2exec g_save.bat>> compiler.txt
     if exist g_save.com del g_save.com
 echo GMS: g_select.bat --->> compiler.txt
   bat2exec g_select.bat>> compiler.txt
     if exist g_select.com del g_select.com
 echo GMS: g_vars.bat --->> compiler.txt
   bat2exec g_vars.bat>> compiler.txt
     if exist g_vars.com del g_vars.com
 echo GMS: g_wel.bat --->> compiler.txt
   bat2exec g_wel.bat>> compiler.txt
     if exist g_wel.com del g_wel.com

 echo GMS: gerolf.bat --->> compiler.txt
 if "%OS%" == "" copy %GMS_SETTING%\gerolf.bat> nul
 if not "%OS%" == "" copy "%GMS_SETTING%\gerolf.bat"> nul
   bat2exec gerolf.bat>> compiler.txt
     if exist gerolf.com del gerolf.com
     if exist gerolf.bat del gerolf.bat
     
 echo GMS: gms.bat --->> compiler.txt
   bat2exec gms.bat>> compiler.txt
     if exist gms.com del gms.com
     
 echo GMS: gmssetup.bat --->> compiler.txt
 if "%OS%" == "" copy %GMS_SETTING%\gmssetup.bat> nul 
 if not "%OS%" == "" copy "%GMS_SETTING%\gmssetup.bat"> nul 
   bat2exec gmssetup.bat>> compiler.txt
     if exist gmssetup.com del gmssetup.com
     if exist gmssetup.bat del gmssetup.bat
     
 echo GMS: gmsunzip.bat --->> compiler.txt
 if "%OS%" == "" copy ..\gmsunzip.bat> nul 
 if not "%OS%" == "" copy "..\gmsunzip.bat"> nul 
   bat2exec gmsunzip.bat>> compiler.txt
     if exist gmsunzip.com del gmsunzip.com
     if exist gmsunzip.bat del gmsunzip.bat     

 echo GMS: l_banner.bat --->> compiler.txt
   bat2exec l_banner.bat>> compiler.txt
 echo GMS: l_box.bat --->> compiler.txt
   bat2exec l_box.bat>> compiler.txt
 echo GMS: l_code.bat --->> compiler.txt
   bat2exec l_code.bat>> compiler.txt
 echo GMS: l_color.bat --->> compiler.txt
   bat2exec l_color.bat>> compiler.txt
 echo GMS: l_desk.bat --->> compiler.txt
   bat2exec l_desk.bat>> compiler.txt
 echo GMS: l_file.bat --->> compiler.txt
   bat2exec l_file.bat>> compiler.txt
 echo GMS: l_gms.bat --->> compiler.txt
   bat2exec l_gms.bat>> compiler.txt
 echo GMS: l_good.bat --->> compiler.txt
   bat2exec l_good.bat>> compiler.txt
 echo GMS: l_list.bat --->> compiler.txt
   bat2exec l_list.bat>> compiler.txt
 echo GMS: l_menu.bat --->> compiler.txt
   bat2exec l_menu.bat>> compiler.txt
 echo GMS: l_prog.bat --->> compiler.txt
   bat2exec l_prog.bat>> compiler.txt
 echo GMS: l_rain.bat --->> compiler.txt
   bat2exec l_rain.bat>> compiler.txt
 echo GMS: l_save.bat --->> compiler.txt
   bat2exec l_save.bat>> compiler.txt
 echo GMS: l_select.bat --->> compiler.txt
   bat2exec l_select.bat>> compiler.txt
 echo GMS: l_wel.bat --->> compiler.txt
   bat2exec l_wel.bat>> compiler.txt
     
 echo GMS: reader.bat --->> compiler.txt
   bat2exec reader.bat>> compiler.txt
     if exist reader.com del reader.com
     
 echo GMS: shredder.bat --->> compiler.txt
   bat2exec shredder.bat>> compiler.txt
     if exist shredder.com del shredder.com
     
 echo GMS: viewer.bat --->> compiler.txt 
   bat2exec viewer.bat>> compiler.txt
     if exist viewer.com del viewer.com

 REM Shorten and view log file ------------------------------------------------

 sed "s/BAT2EXEC.*$//;s/PC Magazine.*$//" < compiler.txt > compiler.tmp 
  sed "s/^.*Douglas Boling//;s/\r//;/^$/d;" < compiler.tmp > compiler.txt
   sed "s/GMS: /\n--- /" < compiler.txt > compiler.tmp
     set arg=compiler.log - GMS: Running batch compiler and syntax checker ...
       echo  %arg%> compiler.pmt
     set arg=////////////////////////////////////////
     if "%OS%" == "Windows_9x" set arg=XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
     if "%winbootdir%" == "." set arg=XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
       echo %arg%%arg%>> compiler.pmt
       echo. >> compiler.pmt
       echo This is BAT2EXEC 1.5, written by Douglas Boling>> compiler.pmt
       echo PC Magazine (c) 1990, 1991 Ziff Communications Co.>> compiler.pmt
         copy compiler.pmt + compiler.tmp compiler.log > nul
       echo. >> compiler.log
       echo %arg%%arg%>> compiler.log
       echo  %GMS_BATCH%>> compiler.log
     set arg=
     if exist compiler.pmt del compiler.pmt
   if exist compiler.tmp del compiler.tmp
 if exist compiler.txt del compiler.txt
 if "%1" == "-quiet" goto fi_v
   set backup_folder=%GMS_FOLDER%
   set backup_file=%GMS_FILE%
   set backup_base=%GMS_BASE%
   set backup_short=%GMS_SHORT%
     set GMS_FOLDER=%GMS_BATCH%
     set GMS_FILE=compiler.log
     set GMS_PROGRAM=batch compiler and syntax checker
     set GMS_COMMAND=%GMS_VIEWER%
     %GMS_DRIVE%
       call g_dos -chdir
       call gms -execute
       cls
 :fi_v 
 
 if "%OS%" == "" cd %GMS_BATCH%
 if not "%OS%" == "" cd "%GMS_BATCH%" 
 if "%OS%" == "" copy compiler.log %GMS_SETTING%> nul 
 if not "%OS%" == "" copy compiler.log "%GMS_SETTING%"> nul
 del compiler.log
 
 :exit
