 REM g_code.bat
 REM ==========

 REM This file is part of Gerolf Markup Shredder, 
 REM written by G. D. Brettschneider (1999-2006).

 REM set GMSdateG_CODE=20060927

 REM Prologue: ================================================================

 REM Not running:

 if not "%GMS_BATCH%" == "" goto fi_nr
   echo  G e r o l f   M a r k u p   S h r e d d e r   (g_code)   . . .
   pause > nul
   gerolf 2> nul
   goto exit
 :fi_nr

 REM Debug: -------------------------------------------------------------------

 if "%OS%" == "" goto fi_db
 if -%GMS_DEBUG% == - goto fi_db
 if %GMS_DEBUG% == Z echo %0 (%1) (%2) (%3) (%4) (%5) (%6) (%7) (%8) >> %Z%
 if %GMS_DEBUG% == X goto then_db
 if not %GMS_DEBUG% == Y goto fi_db
 :then_db
   call l_banner -debug g_code %1 %2 %3 %4
 :fi_db

 REM Chapters: ================================================================

 REM Not defined:

 if not "%1" == "" goto fi_nd
   call l_banner -no_action g_code
   goto exit
 :fi_nd
   
 REM Resize: ------------------------------------------------------------------

 if %1 == -resize goto then_rs
 if %1 == -cp_up_build goto then_b
 if %1 == -cp_lo_build goto then_b
 if not %1 == -remove goto fi_rs
 :then_rs
   set REPLY_OFFSET=3
   set REPLY_SIZE=72
   set REPLY_ITEMS=1
   if %1 == -build goto then_b
   if %1 == -remove goto then_r
   goto exit
 :fi_rs
 
 REM Remove: ------------------------------------------------------------------

 if not %1 == -remove goto fi_r
 :then_r
   call l_rain -remove called_by g_code %1
   call l_banner -lower -folder called_by g_code %1
   goto exit
 :fi_r
   
 REM Build: -------------------------------------------------------------------

 if %1 == -cp_up_build goto then_b
 if not %1 == -cp_lo_build goto fi_b 
 :then_b 
   set BACKUP=%1
   REM Allocate memory:
     set BACKUP_OFFSET=123
     set BACKUP_SIZE=123
     set i=123
     set OFFSET_A=123
     set OFFSET_B=123
     set OFFSET_C=123
     set PAGE=12345
     set REPLY_SIZE=123
     set REPLY_OFFSET=1234567890
   call g_select -remove called_by g_code %1
   call g_menu -remove called_by g_code %1
   if "%1" == "-cp_lo_build" goto else_bb
     if "%OS%" == "" goto else_b1
     if "%OS%" == "Windows_9x" goto else_b1
       REM Remove desktop and switch codepage on Windows:
         call l_desk -remove -nobanners called_by g_code %1
         if not "%GMS_CHCP%" == "" chcp %GMS_CHCP% > nul 2> nul
         cls
         call l_gms -desktop -draw -nofolder called_by g_code %1
       REM Get current codepage, show banner, rebuild desktop:
         call g_dos -current_cp called_by g_code %1
         call l_banner -upper -cp_up called_by g_code %1
         call l_banner -lower -terminal called_by g_code %1
         call g_code -build_cp_desk called_by g_code %1
         goto fi_b1
     :else_b1
       call l_banner -upper -cp_up_dos called_by g_code %1
       call l_banner -lower -codepage called_by g_code %1
     :fi_b1
     REM Build codepage (upper half) and wait:
       call l_code -cp_up called_by g_code %1
       pause > nul
     REM Remove codepage:
       call g_code -remove called_by g_code %1
     if "%OS%" == "" goto else_b2
     if "%OS%" == "Windows_9x" goto else_b2
       set REPLY_OFFSET=0
       set REPLY_SIZE=78
       call l_desk -remove called_by g_code %1
       REM Switch codepage:
         cls
         if not "%GMS_CHCP%" == "" chcp %GMS_INICP% > nul 2> nul
         cls
       REM Show banner, rebuild desktop:
         set GMS_CURCP=%GMS_INICP%
         set REPLY_SIZE=82
         set REPLY_OFFSET=0
         reply -banner 1 "%GMS_FILE%"
         title %GMS_FILE% - GMS
         call l_banner -lower -folder called_by g_code %1
         call g_code -build_cp_desk called_by g_code %1
         goto fi_b2
      :else_b2
        call l_banner -upper -file called_by g_code %1
        call l_banner -lower -folder called_by g_code %1
      :fi_b2
     goto fi_bb
   :else_bb
   REM Show banner, build codepage (lower half), wait, remove codepage:
     call l_banner -upper -cp_lo called_by g_code %1
     call l_code -cp_lo called_by g_code %1
     pause > nul
     call g_code -remove called_by g_code %1
     call l_banner -upper -file called_by g_code %1
   :fi_bb
   REM Build menu: 
     set GMS_COLD=S
     set GMS_HOT=S
     call g_menu -build called_by g_code %1
   REM Free memory:
     set BACKUP=
     set OFFSET_A=
     set OFFSET_B=
     set OFFSET_C=
     set PAGE=
   goto exit
 :fi_b
 
 REM Build codepage desktop: --------------------------------------------------
 
 if not %1 == -build_cp_desk goto fi_cpd
 :then_cpd
   set GMS_RECEIVE=1
   set GMS_RETURN=1
   set REPLY_OFFSET=0
   set REPLY_SIZE=78
   call l_desk -build called_by g_code %1
   set REPLY_OFFSET=00
   goto exit
 :fi_cpd

 REM Not found: ---------------------------------------------------------------

 :else
   call l_banner -no_action g_code %1
   goto exit
 :fi

 :exit
