 REM g_dos.bat
 REM =========

 REM This file is part of Gerolf Markup Shredder,
 REM written by G. D. Brettschneider (1999-2006).

 REM set GMSdateG_DOS=20060927

 REM Prologue: ================================================================

 REM Not running:

 if not "%GMS_BATCH%" == "" goto fi_nr
   echo  G e r o l f   M a r k u p   S h r e d d e r   (g_dos)   . . .
   pause > nul
   gerolf 2> nul
   goto exit
 :fi_nr

 REM Get short name of a file (8 plus 3 characters) on Windows: ---------------

 if not "%1" == "-short" goto fi_s
   set GMS_SHORT=%5
   if "%OS%" == "" goto exit
   if %GMS_DEBUG% == Z echo   GMS_SHORT=%GMS_SHORT%>> %Z%
   goto exit
 :fi_s

 REM Check for spaces within filename: ----------------------------------------

 if not "%1" == "-check_spacy" goto fi_cs
   if not "%2" == "" if not "%3" == "" set GMS_FILE=%GMS_SHORT%
   goto exit
 :fi_cs

 REM Debug: -------------------------------------------------------------------

 if "%OS%" == "" goto fi_db
 if -%GMS_DEBUG% == - goto fi_db
 if %GMS_DEBUG% == Z echo %0 (%1) (%2) (%3) (%4) (%5) (%6) (%7) (%8)>> %Z%
 if %GMS_DEBUG% == X goto then_db
 if not %GMS_DEBUG% == Y goto fi_db
 :then_db
   if "%DEBUG%" == "" goto fi_db1
     call l_banner -debug g_dos %1 %2 %3 %4
   :fi_db1
 :fi_db

 REM Chapters: ================================================================

 REM Not defined:

 if not "%1" == "" goto fi_nd
   call l_banner -no_action g_dos
   goto exit
 :fi_nd

 REM Change directory to GMS_FOLDER, if it exists: ----------------------------

 REM The folder name may contain spaces on Windows, but quoted folder names can
 REM not be recognized on Dos. %GMS_FOLDER%  may be set to a file name. In 
 REM order to find out whether or not a directory really exists, one must try
 REM to change into the new directory and look if the current folder has been
 REM altered.

 REM Fixme: split up into chained parts

 if %1 == -pwd goto then_pwd
 if %1 == -chdir goto then_cd
 if not %1 == -chdir goto fi_cd
   REM Get current folder (PWD): ..............................................
   :then_pwd
     set txt=%GMS_TEMP%\pwd.txt
     cd> %txt%
       set bat=%GMS_TEMP%\pwd.bat
         sed "s/^/set PWD=/" < %txt% > %bat%
         if "%OS%" == "" if not exist %bat% goto fi_pwd1
         if not "%OS%" == "" if not exist "%bat%" goto fi_pwd1
           call %bat%
           if "%OS%" == "" goto elspwd2
             if not "%OS%" == "Windows_9x" del %bat% > nul 2> nul
             if not "%OS%" == "Windows_9x" del %txt% > nul 2> nul   
             if "%OS%" == "Windows_9x" del %bat% > nul
             if "%OS%" == "Windows_9x" del %txt% > nul
             if %GMS_DEBUG% == Z echo   PWD=%PWD%>> %Z%
             goto fi_pwd2
           :elspwd2
             del %bat% > nul
             del %txt% > nul
           :fi_pwd2
         :fi_pwd1
       set bat=
     set txt=
   REM Directory name shall not end with a slash:
     if "%PWD%" == "A:\" set PWD=A:
     if "%PWD%" == "B:\" set PWD=B:
     if "%PWD%" == "C:\" set PWD=C:
     if "%PWD%" == "D:\" set PWD=D:
     if "%PWD%" == "E:\" set PWD=E:
     if "%PWD%" == "F:\" set PWD=F:
     if "%PWD%" == "G:\" set PWD=G:
     if "%PWD%" == "H:\" set PWD=H:
     if "%PWD%" == "I:\" set PWD=I:
     if "%PWD%" == "J:\" set PWD=J:
     if "%PWD%" == "K:\" set PWD=K:
     if "%PWD%" == "L:\" set PWD=L:
     if "%PWD%" == "M:\" set PWD=M:
     if "%PWD%" == "N:\" set PWD=N:
     if "%PWD%" == "O:\" set PWD=O:
     if "%PWD%" == "P:\" set PWD=P:
     if "%PWD%" == "Q:\" set PWD=Q:
     if "%PWD%" == "R:\" set PWD=R:
     if "%PWD%" == "S:\" set PWD=S:
     if "%PWD%" == "T:\" set PWD=T:
     if "%PWD%" == "U:\" set PWD=U:
     if "%PWD%" == "V:\" set PWD=V:
     if "%PWD%" == "W:\" set PWD=W:
     if "%PWD%" == "X:\" set PWD=X:
     if "%PWD%" == "Y:\" set PWD=Y:
     if "%PWD%" == "Z:\" set PWD=Z:
     if "%GMS_STARTUP%" == "" set GMS_STARTUP=%PWD%
     if %1 == -pwd goto exit
   :fi_pwd
 REM Change directory: ........................................................
 :then_cd
   if not "%OS%" == ""  if exist "%GMS_FOLDER%\%any%" goto thencd1 
   if "%OS%" == ""  if exist %GMS_FOLDER%\%any% goto elsecd1
   goto fi_cd1
   :thencd1
     if %GMS_DEBUG% == Z echo   GMS_FOLDER=%GMS_FOLDER%>>%Z%
     if exist "%GMS_FOLDER%\%any%" cd "%GMS_FOLDER%"> nul
     set PWD=%GMS_FOLDER%
     goto fi_cd1
   :elsecd1
     if exist %GMS_FOLDER%\%any% cd %GMS_FOLDER%> nul
     set PWD=%GMS_FOLDER%
   :fi_cd1
   if "%OS%" == "" goto fi_cd2
     if %GMS_DEBUG% == Z echo   PWD=%PWD%>> %Z%
   :fi_cd2
   REM The rest should only be done if a file is given:
     if "%OS%" == "" goto fi_cd3
       if %GMS_DEBUG% == Z echo   GMS_FILE=%GMS_FILE%>> %Z%
     :fi_cd3
     if "%GMS_FILE%" == "" goto exit
   REM Get short name of a file (8 plus 3 characters) on Windows 32: ..........
     set GMS_ERRSHORT=
     set GMS_LOGSHORT=
     if "%OS%" == "" set GMS_SHORT=%GMS_FILE%
     if "%OS%" == "" goto fi_sn
       REM: Fixme: No long file names supported on Windows 9x (no "dir /x"):
         if "%OS%" == "Windows_9x" set GMS_SHORT=%GMS_FILE%
         if "%OS%" == "Windows_9x" goto fi_sn
       REM: Fixme: better get 'find' from Windows subfolder (file.pm analyse) 
         if "%GMS_SKIP%" == "1" set GMS_SHORT=%GMS_FILE%
         if "%GMS_SKIP%" == "1" goto fi_sn
     if "%OS%" == "" if not exist %GMS_FOLDER%\%GMS_FILE% goto fi_sn
     if not "%OS%" == "" if not exist "%GMS_FOLDER%\%GMS_FILE%" goto fi_sn
       set trohs=%GMS_TEMP%\trohs.txt
         dir /x "%GMS_FOLDER%\%GMS_FILE%" | find /i "%GMS_FILE%" > %trohs%
         set short=%GMS_TEMP%\short.bat
           sed "s/^/call g_dos -short /" < %trohs% > %short%
             if exist "%short%" call %short%
             if exist "%short%" del %short%
           REM Fallback:
             if "%GMS_SHORT%" == "" set GMS_SHORT=%GMS_FILE%
             if "%OS%" == "" goto fi_sn1
               if %GMS_DEBUG% == Z echo   GMS_SHORT=%GMS_SHORT%>> %Z%
           :fi_sn1
         set short=
       set trohs=
     REM Replace GMS_FILE by GMS_SHORT, if there are spaces within file name:
       call g_dos -check_spacy %GMS_FILE%
     :fi_sn
   REM Get base name of %GMS_FILE% (without extension): .......................
     set GMS_ERRBASE=
     set GMS_LOGBASE=
     set esab=%GMS_TEMP%\esab.txt
     echo %GMS_FILE%> %esab%
     set base=%GMS_TEMP%\base.bat
       if not exist %esab% goto fi_bn1
       sed "s/\//\\/g;s/\..*$//;s/^/set GMS_BASE=/" < %esab% > %base%
       if "%OS%" == "" if not exist %base% goto fi_bn1
       if not "%OS%" == "" if not exist "%base%" goto fi_bn1
         call %base%
         del %base%
         if exist %esab% del %esab%
         if "%OS%" == "" goto fi_bn1
           if %GMS_DEBUG% == Z echo   GMS_BASE=%GMS_BASE%>> %Z%
       :fi_bn1
     set base=
     set esab=
   goto exit
 :fi_cd

 REM Get file name if %GMS_FILE% contains a path: -----------------------------

 if not %1 == -filename goto fi_fn
   set elif_=%GMS_TEMP%\elif.txt
   echo %GMS_FILE%> %elif_%
     set file_=%GMS_TEMP%\file.bat                   
       if not "%GMS_DRDOS%" == "" goto elsfn1a
         sed "s/\//\\/g;s/^.*\\//;s/^/set file=/;s/\"//g" < %elif_% > %file_%
         goto fi_fn1a
       :elsfn1a
         sed "s/\//\\/g;s/^.*\\//;s/^/set file=/" < %elif_% > %file_%
       :fi_fn1a
       if "%OS%" == "" if not exist %file_% goto fi_fn1
       if not "%OS%" == "" if not exist "%file_%" goto fi_fn1
         call %file_%
         del %file_%
         del %elif_%
       :fi_fn1
       if "%OS%" == "" goto fi_fn2
         if %GMS_DEBUG% == Z echo       file=%file%>> %Z%
       :fi_fn2
     set file_=
   set elif_=
   goto exit
 :fi_fn

 REM Get path name if %GMS_FOLDER% contains %GMS_FILE%: -----------------------

 if not %1 == -pathname goto fi_pn
   set htap_=%GMS_TEMP%\htap_.txt
   echo %GMS_FOLDER%> %htap_%
     set path2_=%GMS_TEMP%\path2_.txt
       if not "%GMS_DRDOS%" == "" goto elspn1a
         sed "s/\//\\/g;s/\"//g" < %htap_% > %path2_%
         goto fi_pn1a
       :elspn1a
         sed "s/\//\\/g" < %htap_% > %path2_%
       :fi_pn1a
       set path_=%GMS_TEMP%\path_.bat
       sed "s/%GMS_FILE%$//;s/\\$//;s/^/set path_=/" < %path2_% > %path_%
         if "%OS%" == "" if not exist %path_% goto fi_pn1
         if not "%OS%" == "" if not exist "%path_%" goto fi_pn1
           call %path_%
           del %path_%
           del %path2_%
           del %htap_%
         :fi_pn1
         if "%OS%" == "" goto fi_pn2
           if %GMS_DEBUG% == Z echo       path_=%path_%>>%Z%
         :fi_pn2
       set path_=
     set path2_=
   set htap_=
   goto exit
 :fi_pn

 REM For each subfolder %%1 do %2 %3 %4 %5 %6 %7 %8 %9 %%1: -------------------

 REM This would bring just the files, not the folders:  
 REM   for %%i in (*) do %2 %3 %3 %4 %5 %%1
 REM So the "dir" function must be used instead (compare g_list -handle).

 if not %1 == -for_folder goto fi_gf
   if not "%GMS_DRDOS%" == "" goto else_dr 
     REM 'dir /b' fails on MS-DOS 3x, so use 'mdir':
     if "%GMS_DRDOS%" == "" if "%OS%" == "" set argdr=mdir /b
     if "%GMS_DRDOS%" == "" if not "%OS%" == "" set argdr=dir /b
     %argdr% /-p /ogen /ad > each.lst
     set argdr=
     sed "s/^/%2 %3 %4 %5 %6 %7 %8 %9 /" < each.lst >> each.bat
     goto fi_dr
   :else_dr
     xdir +d /b /x > each.lst
     sed "s/^../%2 %3 %4 %5 %6 %7 %8 %9 /" < each.lst >> each.bat
   :fi_dr
   if exist each.lst del each.lst
   goto exit
 :fi_gf

 REM Get current codepage number: .............................................

 if not %1 == -current_cp goto fi_cur
   set pchc_=%TEMP%\pchc_.txt
     chcp > %pchc_%
     set chcp_=%TEMP%\chcp_.bat
       if "%GMS_DRDOS%" == "" goto elscur1
         sed "s/....$/:&/;s/^.*: +/set GMS_CURCP=/;s/\.//" < %pchc_% > %chcp_%
         goto fi_cur1
       :elscur1
         sed "s/^.*: //;s/^/set GMS_CURCP=/;s/\.//" < %pchc_% > %chcp_%
       :fi_cur1
       call %chcp_%
       if exist %chcp_% del %chcp_%
     set chcp_=
     if exist %pchc_% del %pchc_%
   set pchc_=
   goto exit
 :fi_cur

 REM Get integer part of %GMS_CODEPAGE%: --------------------------------------

 if not %1 == -get_chcp goto fi_chcp
   set cptmp=%TEMP%\cp.tmp
     set cpbat=%TEMP%\cp.bat
       echo %GMS_CODEPAGE%> %cptmp%
       sed "s/\-//;s/[A-Z]*//;s/[a-z]*//;s/^/set GMS_CHCP=/" <%cptmp% >%cpbat%
       if exist %cpbat% call %cpbat%
       if exist %cpbat% del %cpbat%
       if exist %cptmp% del %cptmp%
     set cpbat=
   set cptmp=
   goto exit
 :fi_chcp
 
 REM Get runtime: -------------------------------------------------------------
  
 if not %1 == -begin_runtime goto fi_brt
   set REPLY_AFTER=0
   set REPLY_BEFORE=0
     if "%OS%" == "" set backup_REPLY_TEMP=%REPLY_TEMP%
     set REPLY_TEMP=runtime.bat
     if "%OS%" == "" if exist %REPLY_TEMP% del %REPLY_TEMP%
     if not "%OS%" == "" if exist "%REPLY_TEMP%" del %REPLY_TEMP%
     if not "%OS%" == "" if not "%OS%" == "Windows_9x" title %GMS_FILE% - Busy
       reply -time
       if "%OS%" == "" if exist %REPLY_TEMP% call %REPLY_TEMP%
       if not "%OS%" == "" if exist "%REPLY_TEMP%" call %REPLY_TEMP%
      if "%OS%" == "" if exist %REPLY_TEMP% del %REPLY_TEMP%
   if not "%OS%" == "" if exist "%REPLY_TEMP%" del %REPLY_TEMP%
   if "%OS%" == "" set REPLY_TEMP=%backup_REPLY_TEMP%
   goto exit
 :fi_brt 
 
 if not %1 == -end_runtime goto fi_ert
   set REPLY_BEFORE=%REPLY_AFTER%
   if "%OS%" == "" set backup_REPLY_TEMP=%REPLY_TEMP%
   set REPLY_TEMP=runtime.bat
   if "%OS%" == "" if exist %REPLY_TEMP% del %REPLY_TEMP%
   if not "%OS%" == "" if exist "%REPLY_TEMP%" del %REPLY_TEMP%
     reply -time
     if "%OS%" == "" if exist %REPLY_TEMP% call %REPLY_TEMP%
     if not "%OS%" == "" if exist "%REPLY_TEMP%" call %REPLY_TEMP%
     if "%OS%" == "" if exist %REPLY_TEMP% del %REPLY_TEMP%
   if not "%OS%" == "" if exist "%REPLY_TEMP%" del %REPLY_TEMP%
   if "%REPLY_AFTER%" == "0" set REPLY_AFTER=less than 1
   if "%OS%" == "" goto fi_ert1
   if "%OS%" == "Windows_9x" goto fi_ert1
     title %GMS_FILE% - %REPLY_AFTER%s
	 :fi_ert1
   if "%OS%" == "" set REPLY_TEMP=%backup_REPLY_TEMP%
   goto exit
 :fi_ert

 REM Not found: ---------------------------------------------------------------

 :else_c
   call l_banner -no_action g_dos %1
 :fi_c

 :exit
