 REM g_file.bat
 REM ==========

 REM This file is part of Gerolf Markup Shredder,
 REM written by G. D. Brettschneider (1999-2006).

 REM set GMSdateG_file=20060927

 REM Prologue: ================================================================

 REM Not running:

 if not "%GMS_BATCH%" == "" goto fi_nr
   echo  G e r o l f   M a r k u p   S h r e d d e r   (g_file)   . . .
   pause > nul
   gerolf 2> nul
   goto exit
 :fi_nr

 REM Debug: -------------------------------------------------------------------

 if "%OS%" == "" goto fi_db
 if -%GMS_DEBUG% == - goto fi_db
 if %GMS_DEBUG% == Z echo %0 (%1) (%2) (%3) (%4) (%5) (%6) (%7) (%8)>> %Z%
 if %GMS_DEBUG% == X goto then_db
 if not %GMS_DEBUG% == Y goto fi_db
 :then_db
   call l_banner -debug g_file %1 %2 %3 %4
 :fi_db

 REM Chapters: ================================================================

 REM Not defined:

 if not "%1" == "" goto fi_nd
   call l_banner -no_action g_file
   goto exit
 :fi_nd

 REM Resize: ------------------------------------------------------------------

 if %1 == -update goto then_rs
 if %1 == -resize goto then_rs
 if %1 == -build goto then_rs
 if not %1 == -remove goto fi_rs
 :then_rs
   set REPLY_OFFSET=3
   set REPLY_SIZE=44
   set REPLY_ITEMS=13
   if %1 == -update goto then_u
   if %1 == -build goto then_b
   if %1 == -remove goto then_r
   goto exit
 :fi_rs

 REM Build: -------------------------------------------------------------------

 if not %1 == -build goto fi_b
 :then_b
   set GMS_STATE=%2
   set GMS_TOPLEVEL=
   call l_box -build called_by g_file %1
   call l_file -build called_by g_file %1
   call g_dos -pwd called_by g_file %1
   set GMS_FOLDER=%PWD%
   call l_banner -lower -folder called_by g_file %1
   set REPLY_LIST=
   call g_list -handle called_by g_file %1
   call l_list -build called_by g_file %1
   set GMS_HOT=N
   if "%GMS_STATE%" == "-folder" set GMS_HOT=H
   call l_file -update %GMS_HOT% %GMS_HOT% called_by g_file %1
   set REPLY_MODULE=g_file
   set REPLY_ACTION=-update
   set GMS_RECEIVE=1
   goto exit
 :fi_b

 REM Remove:-------------------------------------------------------------------

 if not %1 == -remove goto fi_r
 :then_r
   call l_box -remove
   if not %GMS_STATE% == -folder goto fi_r1
     REM Selected a folder to save the new file:
       call g_save -build called_by g_file %1
       goto fi_r2
   :fi_r1
   if not %GMS_STATE% == -template goto else_r2
     REM Selected a template for the new file:
       call g_menu -resize called_by g_file %1
       call l_menu -update C Q called_by g_file %1
       set REPLY_MODULE=g_menu
       set REPLY_ACTION=-update
       set GMS_RECEIVE=1
       goto fi_r2
   :else_r2
     REM Changed folder and opened markup file:
       call g_menu -resize called_by g_file %1
       call l_menu -update O Q called_by g_file %1
       set REPLY_MODULE=g_menu
       set REPLY_ACTION=-update
       set GMS_RECEIVE=1
   :fi_r2
   set GMS_TOPLEVEL=
   goto exit
 :fi_r

 REM Update: ------------------------------------------------------------------

 if not %1 == -update goto fi_u
 :then_u
   REM Cold:
     if not "%3" == "" goto else_u1
       set GMS_COLD=%GMS_HOT%
       goto fi_u1
     :else_u1
       set GMS_COLD=%3
     :fi_u1
   REM Hot:
     if not "%2" == "" goto else_u2
       call l_banner -no_hot called_by g_file %1
       goto fi_u2
     :else_u2
       set GMS_HOT=Q
       if %2 == 1 set GMS_HOT=1
       if %2 == 2 set GMS_HOT=2
       if %2 == 3 set GMS_HOT=3
       if %2 == 4 set GMS_HOT=4
       if %2 == 5 set GMS_HOT=5
       if %2 == 6 set GMS_HOT=6
       if %2 == 7 set GMS_HOT=7
       if %2 == 8 set GMS_HOT=8
       if %2 == 9 set GMS_HOT=9
       if %2 == 11 set GMS_HOT=P
       if %2 == P set GMS_HOT=P
       if %2 == p set GMS_HOT=P
       if %2 == 12 set GMS_HOT=N
       if %2 == N set GMS_HOT=N
       if %2 == n set GMS_HOT=N
       if %2 == 13 set GMS_HOT=H
       if %2 == H set GMS_HOT=H
       if %2 == h set GMS_HOT=H
     :fi_u2
   REM Handle old, update new:
   if not %GMS_HOT% == %GMS_COLD% goto else_u3
     call g_file -handle %GMS_HOT%
     goto fi_u3
     REM goto then_h
   :else_u3
     call l_file -update %GMS_HOT% %GMS_COLD% called_by g_file %1
   :fi_u3
   set GMS_FILETYPE=
   set GMS_NEWFILE=
   set GMS_RECEIVE=1
   goto exit
 :fi_u

 REM Handle: ------------------------------------------------------------------

 if not %1 == -handle goto fi_h
 :then_h

   REM Quit:
     if not %GMS_HOT% == Q goto fi_hq
       call g_file -remove called_by g_file %1
       goto exit
     :fi_hq

   REM Higher:
     if not %GMS_HOT% == H goto fi_hh
       set REPLY_LIST=
       set GMS_FILE=
       call l_banner -upper -first called_by g_file %1
      if not "%OS%" == "" if not "%OS%" == "Windows_9x" title GMS %GMS_VERSION%
       REM Check if it is the top level (drives):
         call g_dos -pwd called_by g_file %1
         set PWD_COLD=%PWD%
         if "%GMS_DRDOS%" == "" if exist ..\%any% cd ..
         if "%GMS_DRDOS%" == "" goto fi_hhdr
           if "%PWD%" == "A:\" goto fi_hhdr
           if "%PWD%" == "B:\" goto fi_hhdr
           if "%PWD%" == "C:\" goto fi_hhdr
           if "%PWD%" == "D:\" goto fi_hhdr
           if "%PWD%" == "E:\" goto fi_hhdr
           if "%PWD%" == "F:\" goto fi_hhdr
           if "%PWD%" == "G:\" goto fi_hhdr
           if "%PWD%" == "H:\" goto fi_hhdr
           if "%PWD%" == "I:\" goto fi_hhdr
           if "%PWD%" == "J:\" goto fi_hhdr
           if "%PWD%" == "K:\" goto fi_hhdr
           if "%PWD%" == "L:\" goto fi_hhdr
           if "%PWD%" == "M:\" goto fi_hhdr
           if "%PWD%" == "N:\" goto fi_hhdr
           if "%PWD%" == "O:\" goto fi_hhdr
           if "%PWD%" == "P:\" goto fi_hhdr
           if "%PWD%" == "Q:\" goto fi_hhdr
           if "%PWD%" == "R:\" goto fi_hhdr
           if "%PWD%" == "S:\" goto fi_hhdr
           if "%PWD%" == "T:\" goto fi_hhdr
           if "%PWD%" == "U:\" goto fi_hhdr
           if "%PWD%" == "V:\" goto fi_hhdr
           if "%PWD%" == "W:\" goto fi_hhdr
           if "%PWD%" == "X:\" goto fi_hhdr
           if "%PWD%" == "Y:\" goto fi_hhdr
           if "%PWD%" == "Z:\" goto fi_hhdr
           cd ..
         :fi_hhdr
         call g_dos -pwd called_by g_file %1
         set PWD_HOT=%PWD%
         set GMS_FOLDER=%PWD%
       REM Handle drive or file/folder/template:
    		 if not "%OS%" == "Windows_9x" goto fi_w9x
           if "%PWD_COLD%" == "A:" goto then_hh1
           if "%PWD_COLD%" == "B:" goto then_hh1
           if "%PWD_COLD%" == "C:" goto then_hh1
           if "%PWD_COLD%" == "D:" goto then_hh1
           if "%PWD_COLD%" == "E:" goto then_hh1
           if "%PWD_COLD%" == "F:" goto then_hh1
           if "%PWD_COLD%" == "G:" goto then_hh1
           if "%PWD_COLD%" == "H:" goto then_hh1
           if "%PWD_COLD%" == "I:" goto then_hh1
           if "%PWD_COLD%" == "J:" goto then_hh1
           if "%PWD_COLD%" == "I:" goto then_hh1
           if "%PWD_COLD%" == "K:" goto then_hh1
           if "%PWD_COLD%" == "L:" goto then_hh1
           if "%PWD_COLD%" == "M:" goto then_hh1
           if "%PWD_COLD%" == "N:" goto then_hh1
           if "%PWD_COLD%" == "O:" goto then_hh1
           if "%PWD_COLD%" == "P:" goto then_hh1
           if "%PWD_COLD%" == "Q:" goto then_hh1
           if "%PWD_COLD%" == "R:" goto then_hh1
           if "%PWD_COLD%" == "S:" goto then_hh1
           if "%PWD_COLD%" == "T:" goto then_hh1
           if "%PWD_COLD%" == "U:" goto then_hh1
           if "%PWD_COLD%" == "V:" goto then_hh1
           if "%PWD_COLD%" == "W:" goto then_hh1
           if "%PWD_COLD%" == "X:" goto then_hh1
           if "%PWD_COLD%" == "Y:" goto then_hh1
           if "%PWD_COLD%" == "Z:" goto then_hh1
				   goto else_hh1
				 :fi_w9x
         if not "%PWD_COLD%" == "%PWD_HOT%" goto else_hh1
				 :then_hh1
           set GMS_TOPLEVEL=1		
           call g_list -drives called_by g_file %1
           goto fi_hh1
         :else_hh1
           set GMS_TOPLEVEL=
           call g_list -handle called_by g_file %1
         :fi_hh1
         set PWD_COLD=
         set PWD_HOT=
       REM Rebuild list:
         call l_list -build called_by g_file %1
         call l_banner -lower -folder called_by g_file %1
         set GMS_RECEIVE=1
         call l_file -update H - called_by g_file %1
       goto exit
     :fi_hh

   REM Previous:
     if not %GMS_HOT% == P goto fi_hp
       if "%REPLY_LIST%" == "" goto fi_hp1
       if not %REPLY_LIST% == * goto else_hp1
       :then_hp1
         set REPLY_LIST=
         goto fi_hp1
       :else_hp1
         REM Diminish list offset by 1:
           set INDEX=
           set d=
           set i=*
           :loop
             set i=%i%*
             set d=%d%*
             if %i%* == %REPLY_LIST%* goto pool
             goto loop
           :pool
           set REPLY_LIST=%d%
           set d=
           set i=
       :fi_hp1
       REM Rebuild list:
         set GMS_RECEIVE=1
         if not "%GMS_TOPLEVEL%" == "" goto else_hp2
           call g_list -handle called_by g_file %1
           goto fi_hp2
         :else_hp2
           call g_list -drives called_by g_file %1
         :fi_hp2
         call l_list -build called_by g_file %1
         call l_file -update P - called_by g_file %1
       goto  exit
     :fi_hp

   REM Next:
     if not %GMS_HOT% == N goto fi_hn
       if "%REPLY9%" == "" goto fi_hnn
         set REPLY_LIST=%REPLY_LIST%*
       :fi_hnn
       set GMS_RECEIVE=1
       if not "%GMS_TOPLEVEL%" == "" goto else_hnm
         call g_list -handle called_by g_file %1
         goto fi_hnm
       :else_hnm
         call g_list -drives called_by g_file %1
       :fi_hnm
       call l_list -build called_by g_file %1
       call l_file -update N - called_by g_file %1
       goto exit
     :fi_hn

   REM Selected file no. 1 - 9:
     if not %GMS_HOT% == 1 goto fi_h1
       set GMS_NEWFILE=%REPLY1%
       set GMS_FILETYPE=%GMS1%
       goto then_hf
     :fi_h1
     if not %GMS_HOT% == 2 goto fi_h2
       set GMS_NEWFILE=%REPLY2%
       set GMS_FILETYPE=%GMS2%
       goto then_hf
     :fi_h2
     if not %GMS_HOT% == 3 goto fi_h3
       set GMS_NEWFILE=%REPLY3%
       set GMS_FILETYPE=%GMS3%
       goto then_hf
     :fi_h3
     if not %GMS_HOT% == 4 goto fi_h4
       set GMS_NEWFILE=%REPLY4%
       set GMS_FILETYPE=%GMS4%
       goto then_hf
     :fi_h4
     if not %GMS_HOT% == 5 goto fi_h5
       set GMS_NEWFILE=%REPLY5%
       set GMS_FILETYPE=%GMS5%
       goto then_hf
     :fi_h5
     if not %GMS_HOT% == 6 goto fi_h6
       set GMS_NEWFILE=%REPLY6%
       set GMS_FILETYPE=%GMS6%
       goto then_hf
     :fi_h6
     if not %GMS_HOT% == 7 goto fi_h7
       set GMS_NEWFILE=%REPLY7%
       set GMS_FILETYPE=%GMS7%
       goto then_hf
     :fi_h7
     if not %GMS_HOT% == 8 goto fi_h8
       set GMS_NEWFILE=%REPLY8%
       set GMS_FILETYPE=%GMS8%
       goto then_hf
     :fi_h8
     if not %GMS_HOT% == 9 goto fi_h9
       set GMS_NEWFILE=%REPLY9%
       set GMS_FILETYPE=%GMS9%
       goto then_hf
     :fi_h9

   REM Handle file or folder:

     if not %GMS_HOT% == -entry goto fi_hf
     :then_hf
       REM Clear all file/folder information:
         set backup_file=
           set GMS_FILE=
         set backup_folder=
           set GMS_FOLDER=
         set backup_short=
           set GMS_SHORT=
           set GMS_ERRSHORT=
           set GMS_LOGSHORT=
         set backup_base=
           set GMS_BASE=
           set GMS_ERRBASE=
           set GMS_LOGBASE=
       REM Check if it is a drive:
         if not -%GMS_FILETYPE% == -[()] goto fi_hf1
           REM Change drive, update GMS_FOLDER:
           REM Fixme: check for spacy names
rem        %GMS_NEWFILE%
           set GMS_REMODRV=%GMS_NEWFILE%
           %GMS_REMODRV%
           call g_dos -pwd called_by g_file %1
           set GMS_FOLDER=%PWD%
           set GMS_FILE=
           goto then_hfo
         :fi_hf1
       REM Check if it is a folder:
         if not -%GMS_FILETYPE% == -[\\] goto fi_hf2
           set GMS_FOLDER=%GMS_NEWFILE%
           if "%OS%" == "" cd %GMS_FOLDER% > nul
           if not "%OS%" == "" cd "%GMS_FOLDER%" > nul
           call g_dos -pwd called_by g_file %1
           set GMS_FOLDER=%PWD%
           set GMS_FILE=
           goto then_hfo
         :fi_hf2
       REM Then it will be a file:
         call g_dos -pwd called_by g_file %1
         set GMS_FOLDER=%PWD%
         set GMS_FILE=%GMS_NEWFILE%
         call g_dos -chdir called_by g_file %1
         if "%GMS_STATE%" == "" goto fi_hf3
         if %GMS_STATE% == -open goto then_hfi
         if %GMS_STATE% == -template goto then_hft
         :fi_hf3 
       goto then_hfi
     :fi_hf

   REM Handle folder:
     if not %GMS_HOT% == -folder goto fi_hfo
     :then_hfo
       call l_banner -upper -first called_by g_file %1
       call l_banner -lower -folder called_by g_file %1
       set REPLY_LIST=
       set GMS_TOPLEVEL=
       call g_list -handle called_by g_file %1
       call l_list -build  called_by g_file %1
       call l_file -update H 1 called_by g_file %1
       set REPLY_MODULE=g_file
       set REPLY_ACTION=-update
       set GMS_RECEIVE=1
       goto exit
     :fi_hfo

   REM Handle file:
     if not %GMS_HOT% == -file goto fi_hfi
     :then_hfi
       if not "%GMS_FILE%" == "" goto else_hfj
         call l_banner -upper -first called_by g_file %1
         goto fi_hfj
       :else_hfj
         call g_vars -ini_file called_by g_file %1
         REM call l_banner -upper -file called_by g_save %1
         set REPLY_SIZE=50
         set REPLY_OFFSET=0
         reply -banner 1 "%GMS_FILE%"         
         if not "%OS%" == "" if not "%OS%" == "Windows_9x" title %GMS_FILE%
       :fi_hfj
       call g_file -resize called_by g_file %1
       call l_box -remove called_by g_file %1
       call g_menu -resize called_by g_file %1
       call l_menu -update O Q called_by g_file %1
       call g_vars -write_memo called_by g_file %1
       set REPLY_MODULE=g_menu
       set REPLY_ACTION=-update
       set GMS_RECEIVE=1
       set GMS_TOPLEVEL=
       goto exit
     :fi_hfi

   REM Handle template:
     if not %GMS_HOT% == -template goto fi_ht
     :then_hft
       set GMS_TEMPLATEFILE=%GMS_NEWFILE%
       call g_dos -pwd called_by g_file %1
       set GMS_TFOLDER=%PWD%
       call l_banner -upper -template called_by g_file %1
       set GMS_FOLDER=%GMS_LASTDIR%
       set GMS_LASTDIR=
       call g_dos -chdir called_by g_file %1
       REM Select folder:
         set BACKUP_ANIMATE=%GMS_ANIMATE%
           set GMS_ANIMATE=off
             set GMS_FILEBOX=2. Select a folder to save this new copy
               set GMS_FOLDER=%GMS_TEMPLATE%
               if "%HOMEPATH%" == "" goto fi_ht1
                 %HOMEDRIVE%
                 set GMS_FOLDER=%HOMEDRIVE%\%HOMEPATH%
               :fi_ht1
               call g_dos -chdir called_by g_file %1
               call g_file -build -folder called_by g_file %1
             set GMS_FILEBOX=
           set GMS_ANIMATE=%BACKUP_ANIMATE%
         set BACKUP_ANIMATE=
         set GMS_TOPLEVEL=
         goto exit
     :fi_ht

   REM Not found:
   :else_h
     call l_banner -no_hot g_file %GMS_HOT%
     goto exit
   :fi_h

 REM Not found: ---------------------------------------------------------------

   call l_banner -no_action g_file %1

 :exit

   set GMS_NEWFILE=
