 REM g_list.bat
 REM ==========
 
 REM This file is part of Gerolf Markup Shredder,
 REM written by G. D. Brettschneider (1999-2006).

 REM set GMSdateG_LIST=20060927

 REM Prologue: ================================================================

 REM Not running:

 if not "%GMS_BATCH%" == "" goto fi_nr
   echo  G e r o l f   M a r k u p   S h r e d d e r   (g_list)   . . .
   pause > nul
   gerolf 2> nul
   goto exit
 :fi_nr

 REM Debug: -------------------------------------------------------------------

 if "%OS%" == "" goto fi_db
 if -%GMS_DEBUG% == - goto fi_db
 if %GMS_DEBUG% == Z echo %0 (%1) (%2) (%3) (%4) (%5) (%6) (%7) (%8)>> %Z%
 if %GMS_DEBUG% == X goto then_db
 if not %GMS_DEBUG% == Y goto fi_db
 :then_db
   call l_banner -debug g_list %1 %2 %3 %4
 :fi_db

 REM Chapters: ================================================================

 REM Not defined:

 if not "%1" == "" goto fi_nd
   call l_banner -no_action g_list
   goto exit
 :fi_nd

 REM Clear/Handle:-------------------------------------------------------------

 if %1 == -clear goto then_cl
 if not %1 == -handle goto fi_h 

   REM Clear: .................................................................

   :then_cl
     set FULL=
     set INDEX=
     REM file names:
       set REPLY1=
       set REPLY2=
       set REPLY3=
       set REPLY4=
       set REPLY5=
       set REPLY6=
       set REPLY7=
       set REPLY8=
       set REPLY9=
     REM Folder marks \\ :
       set GMS1=
       set GMS2=
       set GMS3=
       set GMS4=
       set GMS5=
       set GMS6=
       set GMS7=
       set GMS8=
       set GMS9=
     if %1 == -clear goto exit
   :fi_cl

   REM Handle: ................................................................
  
   REM Fixme: put tmp files in user directory to avoid interference
   set tmp1=%GMS_TEMP%\tmp1.tmp
   set tmp2=%GMS_TEMP%\tmp2.tmp
   set tmp3=%GMS_TEMP%\tmp3.tmp
   set tmp4=%GMS_TEMP%\tmp4.bat
   REM There must be at least one fake file in a folder:
     if not exist _fake_.tmp echo. > _fake_.tmp 2> nul
   REM Then I can build a list of folders (/ad) and files (/a-d):
     if not "%GMS_DRDOS%" == "" goto else_dr 
       REM 'dir /b' fails on MS-DOS 3x, so use 'mdir':
       if "%GMS_DRDOS%" == "" if "%OS%" == "" set argdr=mdir /b
       if "%GMS_DRDOS%" == "" if not "%OS%" == "" set argdr=dir /b
       %argdr% /-p /ogen /ad | sed "s/^/-d /" > %tmp1% 
       if not exist *.* goto fi_dr 
       %argdr% /-p /ogen /a-d | sed "s/^/-f /" >> %tmp1%
       goto fi_dr
     :else_dr
       xdir +d /x | sed "s/^.*:/-d /;1,2d;$d" > %tmp1%
       if not exist %any% goto fi_dr 
       xdir -d /x | sed "s/^.*:/-f /;$d" >> %tmp1%   
     :fi_dr
     set argdr=
   REM Remove fake file from folder and list:
     if exist _fake_.tmp del _fake_.tmp
     sed "/-f _fake_\.tmp/d" < %tmp1% > %tmp2%
     if exist %tmp1% del %tmp1%
   REM Shorten list by 8 lines (top) during each loop:
     copy %tmp2% %tmp1% > nul
     set _diff=
       if "%REPLY_LIST%" == "" goto spool
       :loops
         sed "1,8d" < %tmp1% > %tmp2%
         if exist %tmp1% del %tmp1%
         copy %tmp2% %tmp1% > nul
         if "%_diff%*" == "%REPLY_LIST%" goto spool
         set _diff=%_diff%*
         goto loops
       :spool
     set _diff=
   REM Shorten rest of list (bottom):
     sed "1,9!d" < %tmp2% > %tmp1%
     if exist %tmp2% del %tmp2%
   REM Add line numbers and replace them with list variables:
     sed = %tmp1% | sed "N;s/\n/ /;s/^./set REPLY&=/" > %tmp3%
     if exist %tmp1% del %tmp1%
   REM Remove old folder/file mark:
     sed "s/ -f //;s/ -d //" < %tmp3% > %tmp4%
   REM Set new file/folder/drive mark:
     sed "s/REPLY/GMS/;s/ -f .*$/    /;s/ -d .*$/\[\\\\\]/" < %tmp3% >> %tmp4%
     call %tmp4%
     if exist %tmp4% del %tmp4%
     if exist %tmp3% del %tmp3%
   set tmp1=
   set tmp2=
   set tmp3=
   set tmp4=
   goto exit
 :fi_h

 REM Drives: ------------------------------------------------------------------

 if not %1 == -drives goto fi_d
   set str=[()]
   set GMS1=%str%
   set GMS2=%str%
   set GMS3=%str%
   set GMS4=%str%
   set GMS5=%str%
   set GMS6=%str%
   set GMS7=%str%
   set GMS8=%str%
   set GMS9=%str%
   if not "%REPLY_LIST%" == "" goto fi_d1
     set REPLY1=A:
     set REPLY2=B:
     set REPLY3=C:
     set REPLY4=D:
     set REPLY5=E:
     set REPLY6=F:
     set REPLY7=G:
     set REPLY8=H:
     set REPLY9=I:
     goto exit
   :fi_d1
   if not "%REPLY_LIST%" == "*" goto fi_d2
     set REPLY1=I:
     set REPLY2=J:
     set REPLY3=K:
     set REPLY4=L:
     set REPLY5=M:
     set REPLY6=N:
     set REPLY7=O:
     set REPLY8=P:
     set REPLY9=Q:
     goto exit
   :fi_d2
   if not "%REPLY_LIST%" == "**" goto fi_d3
     set REPLY1=Q:
     set REPLY2=R:
     set REPLY3=S:
     set REPLY4=T:
     set REPLY5=U:
     set REPLY6=V:
     set REPLY7=W:
     set REPLY8=X:
     set REPLY9=Y:
     goto exit
   :fi_d3
   if not "%REPLY_LIST%" == "***" goto fi_d4
     set REPLY1=Y:
     set REPLY2=Z:
     set REPLY3=
     set REPLY4=
     set REPLY5=
     set REPLY6=
     set REPLY7=
     set REPLY8=
     set REPLY9=
     set GMS3=
     set GMS4=
     set GMS5=
     set GMS6=
     set GMS7=
     set GMS8=
     set GMS9=
     goto exit
   :fi_d4
   goto exit
 :fi_d

 REM Not found: ---------------------------------------------------------------

 :else
   call l_banner -no_action g_list %1
 :fi

 :exit
