 REM g_plug.bat
 REM ==========

 REM This file is part of Gerolf Markup Shredder,
 REM written by G. D. Brettschneider (1999-2006).

 REM set GMSdateG_PLUG=20060927

 REM Prologue: ================================================================

 REM Not running:

 if not "%GMS_BATCH%" == "" goto fi_nr
   echo  G e r o l f   M a r k u p   S h r e d d e r   (g_plug)   . . .
   pause > nul
   gerolf
   goto exit
 :fi_nr

 REM Debug: -------------------------------------------------------------------

 if "%OS%" == "" goto fi_db
 if -%GMS_DEBUG% == - goto fi_db
 if %GMS_DEBUG% == Z echo %0 (%1) (%2) (%3) (%4) (%5) (%6) (%7) (%8)>> %Z%
 if %GMS_DEBUG% == X goto then_db
 if not %GMS_DEBUG% == Y goto fi_db
 :then_db
   call l_banner -debug g_plug %1 %2 %3 %4
 :fi_db

 REM Chapters: ================================================================

 REM Not defined:

 if not "%1" == "" goto fi_nd
   call l_banner -no_action g_plug
   goto exit
 :fi_nd

 REM Rebuild list of plug-in modules: -----------------------------------------
 
 if not %1 == -rebuild goto fi_rb
   if "%OS%" == "" set plug=%GMS_SETTING%\plugin.cfg
   if not "%OS%" == "" set plug="%GMS_SETTING%\plugin.cfg"
   set str=%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   REM Display info:
     set REPLY_BANNER=0
     set REPLY_TEXT=7
     set REPLY_OFFSET=0
     set REPLY_SIZE=16
       reply -banner 17 Writing:
     set REPLY_OFFSET=14
     set REPLY_SIZE=68
       reply -banner 17 "  %GMS_SETTING%\plugin.cfg"
   REM Initial data:
     echo  %% plugin.cfg> %plug%
     echo  %% ==========>> %plug%
     echo.>> %plug%
     echo  %% This TeX file was auto->> %plug%
     echo  %% generated by Gerolf Markup Shredder,>> %plug%
     echo  %% written by G. D. Brettschneider (1999-2004).>> %plug%
     echo  %% All rights reserved.>> %plug%
     echo  %% Send corrections to: MarkupShredder@Gerolf.org>> %plug%
     echo  %% Subject: GMS TeX macros (module loader)>> %plug%
     echo.>> %plug%
     echo  %% This file serves for loading all GMS>> %plug%
     echo  %% modules that could be found in the>> %plug%
     echo  %% appropriate plug-in directories.>> %plug%
     echo  %% If you have reason to edit this file,>> %plug%
     echo  %% change its name to 'myplugin.cfg'.>> %plug%
     echo  %% The recommended way to add TeX macro files>> %plug%
     echo  %% to GMS, however, is to \input them in>> %plug%
     echo  %% 'prologue.cfg' or 'epilogue.cfg'.>> %plug%
     echo.>> %plug%
     echo  %%%str%%str%%%>> %plug%
     echo.>> %plug%
     echo  %% Initial data:>> %plug%
     echo    \def \GMSdate {%GMS_DATE%}>> %plug% 
     echo    \def \GMSversion {%GMS_VERSION%}>> %plug%
     echo    \def \GMScodepage {%GMS_CODEPAGE%}>> %plug%
     echo    \def \GMSdebug {%GMS_DEBUG%}>> %plug%
     echo    \def \OS {%OS%}>> %plug%
     echo.>> %plug%
     echo  %%%str%%str%%%>> %plug%
     echo.>> %plug%
   REM Modules:
     echo  \hyphenmessage>> %plug%
     echo  \message {Module loader.}>> %plug%
     echo  \fillmessage 42{modules}5>> %plug%
     echo.>> %plug%
   REM Fonts:
     echo    \fillmessage 6a{font}6>> %plug%
     echo      \MAPload>> %plug%
     echo      \hyphenmessage>> %plug%
     echo      \message {( font.map}>> %plug%
     echo      \hyphenmessage>> %plug%
     if "%OS%" == "Windows_9x" goto fi_9x1
       echo      \message {These names can be used as font face or}>> %plug%
       echo      \echo {font-family style names in markup files:}>> %plug%
       echo      \MAPfamilyshow>> %plug%
     :fi_9x1
     echo      \message {)}>> %plug%
     echo    \fillmessage 6-{/font}5>> %plug%
     echo.>> %plug%
   REM Kerning tables:
     echo    \fillmessage 6b{kerning}3>> %plug%
     if "%OS%" == "" cd %GMS_ROOT%\data\krn > nul
     if not "%OS%" == "" cd "%GMS_ROOT%\data\krn" > nul
     for %%i in (*.krn) do echo      \KERNINGparseline (%%i)\relax>> %plug%
     echo      \KERNINGloadtables>> %plug%
     echo    \fillmessage 6-{/kerning}2>> %plug%
     echo.>> %plug%
   REM Hyphenation patterns:
     if "%OS%" == "" cd %GMS_ROOT%\tex\hyphen > nul
     if not "%OS%" == "" cd "%GMS_ROOT%\tex\hyphen" > nul 
     echo    \fillmessage 6c{language}2>> %plug%
     for %%i in (*.tex) do echo        \LANGUAGEadd %%i>> %plug%
     echo      \LANGUAGEloadpatterns>> %plug%
     echo      \message {More pattern files are available at>> %plug%
     echo        http://www.ctan.org/tex-archive/language//}>> %plug%
     echo    \fillmessage 6-{/language}1>> %plug%
     echo.>> %plug%
   REM Unicode rows:
     echo    \fillmessage 6d{unicode}3>> %plug%
     if "%OS%" == "" cd %GMS_ROOT%\data\row > nul
     if not "%OS%" == "" cd "%GMS_ROOT%\data\row" > nul
     for %%i in (*.row) do echo        \UNICODEadd %%i>> %plug%
     echo      \UNICODEslotsload>> %plug%
     echo    \fillmessage 6-{/unicode}2>> %plug%
     echo.>> %plug%
   REM Entity names:
     echo    \fillmessage 6e{entity}4>> %plug%
     if "%OS%" == "" cd %GMS_ROOT%\data\ent > nul 
     if not "%OS%" == "" cd "%GMS_ROOT%\data\ent" > nul 
     for %%i in (*.ent) do echo        \ENTITYadd %%i>> %plug%
     echo      \ENTITYnamesload>> %plug%
     if not "%OS%" == "Windows_9x" echo      \ENTITYnamesshow>> %plug%
     echo    \fillmessage 6-{/entity}3>> %plug%
     echo.>> %plug%
   REM Glyph names:
     echo    \fillmessage 6f{glyph}5>> %plug%
     if "%OS%" == "" cd %GMS_ROOT%\data\gly> nul 
     if not "%OS%" == "" cd "%GMS_ROOT%\data\gly"> nul 
     for %%i in (*.gly) do echo        \GLYPHSadd %%i>> %plug%
     echo      \GLYPHSnamesload>> %plug%
     echo    \fillmessage 6-{/glyph}4>> %plug%
     echo.>> %plug%
   REM Codepages:
     echo    \fillmessage 6g{codepage}2>> %plug%
     if "%OS%" == "" cd %GMS_ROOT%\data\cp > nul
     if not "%OS%" == "" cd "%GMS_ROOT%\data\cp" > nul
     for %%i in (*.txt) do echo        \CODEPAGEadd %%i>> %plug%
     echo      \CODEPAGEloadthem>> %plug%
     echo      \CODEPAGEencwrite>> %plug%
     echo      \expandafter \CODEPAGEenable \CODEPAGE \relax>> %plug% 
REM  echo      \UNICODEencswrite\relax>> %plug%
     echo    \fillmessage 6-{/codepage}1>> %plug%
     echo.>> %plug%
     echo  \fillmessage 4-{/modules}3>> %plug%
     echo  \endinput>> %plug%
   if "%OS%" == "" cd %GMS_BINARIES% > nul
   if not "%OS%" == "" cd "%GMS_BINARIES%" > nul
   set plug=
   goto exit
 :fi_rb

 REM Build plugin.cfg, but consider myplugin.cfg: -----------------------------

 REM Fixme:
 if not %1 == -build goto fi_b 
   REM Write new plugin.cfg, if myplugin.cfg does not exist:
     if "%OS%" == "" if exist %GMS_SETTING%\myplugin.cfg goto fi_i1
     if not "%OS%" == "" if exist "%GMS_SETTING%\myplugin.cfg" goto fi_i1
       call g_plug -rebuild called_by g_plug %1
     :fi_i1
   REM If myplugin.cfg exists, copy it to plugin.cfg:
     if "%OS%" == "" if exist %GMS_SETTING%\myplugin.cfg goto then_i2
     if not "%OS%" == "" if exist "%GMS_SETTING%\myplugin.cfg" goto else_i2
     goto fi_i2
     :then_i2
       copy %GMS_SETTING%\myplugin.cfg %GMS_SETTING%\plugin.cfg > nul
       goto fi_i2
     :else_i2
       copy "%GMS_SETTING%\myplugin.cfg" "%GMS_SETTING%\plugin.cfg" > nul
     :fi_i2
   REM Write new plugin.cfg, if plugin.cfg does not exist:
     if "%OS%" == "" if exist %GMS_SETTING%\plugin.cfg goto fi_i3
     if not "%OS%" == "" if exist "%GMS_SETTING%\plugin.cfg" goto fi_i3
       call g_plug -rebuild g_plug %1
     :fi_i3
   goto exit
 :fi_b

 REM Remove plugin.cfg: -------------------------------------------------------

 if not %1 == -remove goto fi_rp
   REM If myplugin.cfg and plugin.cfg exist, delete plugin.cfg:
     if "%OS%" == "" if exist %GMS_SETTING%\myplugin.cfg goto then_i4
     if not "%OS%" == "" if exist "%GMS_SETTING%\myplugin.cfg" goto else_i4
     goto fi_i4
     :then_i4
       if exist %GMS_SETTING%\plugin.cfg del %GMS_SETTING%\plugin.cfg
       goto fi_i4
     :else_i4
       if exist "%GMS_SETTING%\plugin.cfg" del "%GMS_SETTING%\plugin.cfg"
     :fi_i4
   goto exit
 :fi_rp

 REM Not found: ---------------------------------------------------------------

 :else
   call l_banner -no_action g_plug %1 
 :fi

 :exit
