 REM shredder.bat
 REM ============

 REM This file is part of Gerolf Markup Shredder,
 REM written by G. D. Brettschneider (1999-2006).

 REM set GMSdateSHREDDER=20060927

 REM Prologue: ================================================================

 REM Not running:

 if not "%GMS_BATCH%" == "" goto fi_nr
   echo  G e r o l f   M a r k u p   S h r e d d e r   (shredder.bat)   . . .
   pause > nul
   gerolf 2> nul
   goto exit
 :fi_nr

 REM Check if module is given: ------------------------------------------------

 if not "%1" == "" goto fi_0
   if not exist ..\gerolf goto else_0e
     REM Load launcher (if not loaded by launcher):
     call ..\gerolf -passive shredder
     set REPLY_MODULE=g_palet
     set REPLY_ACTION=-build
   :else_0e
     REM Not set up:
     echo.
     echo Please run 'gmssetup' script to initialize Gerolf Markup Shredder.
     goto exit
   :fi_0e
 :fi_0

 REM Help message: ------------------------------------------------------------

 if %1 == /help goto then_h
 if not %1 == -help goto else_h
 :then_h
   echo.
   echo This is Gerolf Markup Shredder, 
   echo written by G. D. Brettschneider (www.Gerolf.org) 
   echo Please send bug reports or corrections to 
   echo MarkupShredder@Gerolf.org - Thank you. 
   goto exit
 :else_h
   REM Initialize loop:
   set REPLY_MODULE=%1
   set REPLY_ACTION=%2
 :fi_h

 REM Debug: -------------------------------------------------------------------

 if "%OS%" == "" goto fi_db
 if -%GMS_DEBUG% == - goto fi_db
 if %GMS_DEBUG% == Z echo %0 (%1) (%2) (%3) (%4) (%5) (%6) (%7) (%8)>> %Z%
 if %GMS_DEBUG% == X goto then_db
 if not %GMS_DEBUG% == Y goto fi_db
 :then_db
   call l_banner -debug %1 %2 %3 %4
 :fi_db
  
 REM Build: -------------------------------------------------------------------
 
 set REPLY_TEMP=%GMS_TEMP%\replytmp.bat
 if "%OS%" == "" if not exist %GMS_TEMP%\replytmp.bat goto fi_bb
 if not "%OS%" == "" if not exist "%GMS_TEMP%\replytmp.bat" goto fi_bb 
   del %GMS_TEMP%\replytmp.bat
 :fi_bb
 set REPLY_MODULE=g_palet
 set REPLY_ACTION=-build
 set REPLY_OFFSET=0 
 set REPLY_SIZE=0
 set REPLY_ITEMS=0
 reply -random 2 
 set GMS_RECEIVE=1
 set GMS_TEXTMODE=1

 REM Textmode interface master loop: ==========================================
 
 if "%OS%" == "" goto repeat
 if not %GMS_DEBUG% == Z goto repeat
   echo ---------- Entering textmode interface master loop>> %Z%

 :repeat

   set REPLY_DATA=

   REM Load and remove old temporary file 'replytmp': -------------------------

   if -%GMS_RECEIVE% == - goto fi_r
   if not -%GMS_RECEIVE% == -1 goto fi_r
     if "%OS%" == "" if not exist %REPLY_TEMP% goto fi_rr
     if not "%OS%" == "" if not exist "%REPLY_TEMP%" goto fi_rr
       call %REPLY_TEMP%
       del %REPLY_TEMP%
       set GMS_RECEIVE=0
     :fi_rr
   :fi_r

   REM Debug: -----------------------------------------------------------------

   if -%GMS_DEBUG% == - goto fi_db2
     set arg=(%REPLY_MODULE%) (%REPLY_ACTION%)
     set arg=%arg% (%REPLY_HOT%) (%REPLY_COLD%) (%REPLY_DATA%)       
       if "%OS%" == "" goto fi_db20
         if %GMS_DEBUG% == Z echo -------------------- %0 %arg%>> %Z%
       :fi_db20  
       if %GMS_DEBUG% == X goto then_db3
       if not %GMS_DEBUG% == Y goto fi_db3
       :then_db3
         set arg=%REPLY_MODULE% %REPLY_ACTION%
         set arg=%arg% %REPLY_HOT% %REPLY_COLD% %REPLY_DATA%
           call l_banner -debug %arg%
       :fi_db3
     set arg=
   :fi_db2

   REM Load module: -----------------------------------------------------------

  if "%OS%" == "" if not exist %GMS_BATCH%\%REPLY_MODULE%.bat goto else_l
  if not "%OS%" == "" if not exist "%GMS_BATCH%\%REPLY_MODULE%.bat" goto else_l
     call %REPLY_MODULE% %REPLY_ACTION% %REPLY_HOT% %REPLY_COLD% %REPLY_DATA%
     goto fi_l

   REM Not found: -------------------------------------------------------------

   :else_l 
     call l_banner -no_module %REPLY_MODULE% shredder
     goto exit
   :fi_l

   if -%GMS_BREAK% == - goto repeat
   if not %GMS_BREAK% == 1 goto repeat

 :taeper
   REM gmsdebug.log footer:
     if "%OS%" == "" goto fi_left
     if not %GMS_DEBUG% == Z goto fi_left
       echo ---------- Leaving textmode interface master loop>> %Z%
       set arg=////////////////////////////////////////
      if "%OS%" == "Windows_9x" set arg=XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
         echo %arg%%arg%%arg%>> %Z%
       set arg=
       echo. %GMS_SETTING%>> %Z%
     :fi_left
   REM Final screen:
     cls
     if "%OS%" == "" goto else_gb
       echo  G e r o l f   M a r k u p   S h r e d d e r   . . .
       goto fi_gb
     :else_gb
       echo Please support the author of Markup Shredder - www.Gerolf.org
     :fi_gb
     for %%i in (1 2 3 4 5 6 7 8 9 10 11) do echo.
     for %%i in (1 2 3 4 5 6 7 8 9 10) do echo.
     if "%OS%" == "" echo.

 :exit
   REM Final unsets:
     if "%OS%" == "Windows_9x" set OS=
     if "%OS%" == "Windows_XP" set OS=Windows_NT
     if not "%GMS_DOSMODE%" == "" set windir=
     set GMS_BREAK=
     set GMS_DEBUG=
     set GMS_DOSMODE=
     set GMS_SETTING=
     set Z=
